Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp	(revision 46461)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.cpp	(revision 46473)
@@ -75,5 +75,5 @@
 bool UIMachineSettingsDisplay::isAcceleration2DVideoSelected() const
 {
-    return mCb2DVideo->isChecked();
+    return m_pCheckbox2DVideo->isChecked();
 }
 #endif /* VBOX_WITH_VIDEOHWACCEL */
@@ -140,11 +140,11 @@
 
     /* Load Video data to page: */
-    m_pSliderScreeens->setValue(displayData.m_cGuestScreenCount);
-    mCb3D->setChecked(displayData.m_f3dAccelerationEnabled);
-#ifdef VBOX_WITH_VIDEOHWACCEL
-    mCb2DVideo->setChecked(displayData.m_f2dAccelerationEnabled);
+    m_pSliderVideoScreenCount->setValue(displayData.m_cGuestScreenCount);
+    m_pCheckbox3D->setChecked(displayData.m_f3dAccelerationEnabled);
+#ifdef VBOX_WITH_VIDEOHWACCEL
+    m_pCheckbox2DVideo->setChecked(displayData.m_f2dAccelerationEnabled);
 #endif /* VBOX_WITH_VIDEOHWACCEL */
     checkVRAMRequirements();
-    m_pSliderMemory->setValue(displayData.m_iCurrentVRAM);
+    m_pSliderVideoMemorySize->setValue(displayData.m_iCurrentVRAM);
 
     /* If Remote Display server is supported: */
@@ -184,9 +184,9 @@
 
     /* Gather Video data from page: */
-    displayData.m_iCurrentVRAM = m_pSliderMemory->value();
-    displayData.m_cGuestScreenCount = m_pSliderScreeens->value();
-    displayData.m_f3dAccelerationEnabled = mCb3D->isChecked();
-#ifdef VBOX_WITH_VIDEOHWACCEL
-    displayData.m_f2dAccelerationEnabled = mCb2DVideo->isChecked();
+    displayData.m_iCurrentVRAM = m_pSliderVideoMemorySize->value();
+    displayData.m_cGuestScreenCount = m_pSliderVideoScreenCount->value();
+    displayData.m_f3dAccelerationEnabled = m_pCheckbox3D->isChecked();
+#ifdef VBOX_WITH_VIDEOHWACCEL
+    displayData.m_f2dAccelerationEnabled = m_pCheckbox2DVideo->isChecked();
 #endif /* VBOX_WITH_VIDEOHWACCEL */
 
@@ -275,7 +275,7 @@
 {
     m_pValidator = pValidator;
-    connect(mCb3D, SIGNAL(stateChanged(int)), m_pValidator, SLOT(revalidate()));
-#ifdef VBOX_WITH_VIDEOHWACCEL
-    connect(mCb2DVideo, SIGNAL(stateChanged(int)), m_pValidator, SLOT(revalidate()));
+    connect(m_pCheckbox3D, SIGNAL(stateChanged(int)), m_pValidator, SLOT(revalidate()));
+#ifdef VBOX_WITH_VIDEOHWACCEL
+    connect(m_pCheckbox2DVideo, SIGNAL(stateChanged(int)), m_pValidator, SLOT(revalidate()));
 #endif /* VBOX_WITH_VIDEOHWACCEL */
     connect(m_pCheckboxRemoteDisplay, SIGNAL(toggled(bool)), m_pValidator, SLOT(revalidate()));
@@ -289,5 +289,5 @@
     checkVRAMRequirements();
 
-    if (mCb3D->isChecked() && !vboxGlobal().is3DAvailable())
+    if (m_pCheckbox3D->isChecked() && !vboxGlobal().is3DAvailable())
     {
         strWarning = tr("you enabled 3D acceleration. However, 3D acceleration is not "
@@ -300,8 +300,8 @@
     if (shouldWeWarnAboutLowVideoMemory() && !m_guestOSType.isNull())
     {
-        quint64 uNeedBytes = VBoxGlobal::requiredVideoMemory(m_guestOSType.GetId(), m_pSliderScreeens->value());
+        quint64 uNeedBytes = VBoxGlobal::requiredVideoMemory(m_guestOSType.GetId(), m_pSliderVideoScreenCount->value());
 
         /* Basic video RAM amount test: */
-        if ((quint64)m_pSliderMemory->value() * _1M < uNeedBytes)
+        if ((quint64)m_pSliderVideoMemorySize->value() * _1M < uNeedBytes)
         {
             strWarning = tr("you have assigned less than <b>%1</b> of video memory which is "
@@ -313,8 +313,8 @@
 #ifdef VBOX_WITH_VIDEOHWACCEL
         /* 2D acceleration video RAM amount test: */
-        if (mCb2DVideo->isChecked() && m_f2DVideoAccelerationSupported)
+        if (m_pCheckbox2DVideo->isChecked() && m_f2DVideoAccelerationSupported)
         {
             uNeedBytes += VBoxGlobal::required2DOffscreenVideoMemory();
-            if ((quint64)m_pSliderMemory->value() * _1M < uNeedBytes)
+            if ((quint64)m_pSliderVideoMemorySize->value() * _1M < uNeedBytes)
             {
                 strWarning = tr("you have assigned less than <b>%1</b> of video memory which is "
@@ -327,11 +327,11 @@
 #if 0
 # ifdef VBOX_WITH_CRHGSMI
-        if (mCb3D->isChecked() && m_fWddmModeSupported)
+        if (m_pCheckbox3D->isChecked() && m_fWddmModeSupported)
         {
-            int cGuestScreenCount = m_pSliderScreeens->value();
+            int cGuestScreenCount = m_pSliderVideoScreenCount->value();
             uNeedBytes += VBoxGlobal::required3DWddmOffscreenVideoMemory(m_guestOSType.GetId(), cGuestScreenCount);
-            uNeedBytes = RT_MAX(uNeedBytes, 128 * _1M);
-            uNeedBytes = RT_MIN(uNeedBytes, 256 * _1M);
-            if ((quint64)m_pSliderMemory->value() * _1M < uNeedBytes)
+            uNeedBytes = qMax(uNeedBytes, 128 * _1M);
+            uNeedBytes = qMin(uNeedBytes, 256 * _1M);
+            if ((quint64)m_pEditorVideoMemorySize->value() * _1M < uNeedBytes)
             {
                 strWarning = tr("you have 3D Acceleration enabled for a operation system which uses the WDDM video driver. "
@@ -348,5 +348,5 @@
 #ifdef VBOX_WITH_VIDEOHWACCEL
     /* 2D video acceleration is available for Windows guests only: */
-    if (mCb2DVideo->isChecked() && !m_f2DVideoAccelerationSupported)
+    if (m_pCheckbox2DVideo->isChecked() && !m_f2DVideoAccelerationSupported)
     {
         strWarning = tr("you have 2D Video Acceleration enabled. As 2D Video Acceleration "
@@ -363,14 +363,14 @@
     /* Video tab-order */
     setTabOrder(pWidget, m_pTabWidget->focusProxy());
-    setTabOrder(m_pTabWidget->focusProxy(), m_pSliderMemory);
-    setTabOrder(m_pSliderMemory, m_pEditorMemory);
-    setTabOrder(m_pEditorMemory, m_pSliderScreeens);
-    setTabOrder(m_pSliderScreeens, m_pEditorScreens);
-    setTabOrder(m_pEditorScreens, mCb3D);
-#ifdef VBOX_WITH_VIDEOHWACCEL
-    setTabOrder(mCb3D, mCb2DVideo);
-    setTabOrder(mCb2DVideo, m_pCheckboxRemoteDisplay);
+    setTabOrder(m_pTabWidget->focusProxy(), m_pSliderVideoMemorySize);
+    setTabOrder(m_pSliderVideoMemorySize, m_pEditorVideoMemorySize);
+    setTabOrder(m_pEditorVideoMemorySize, m_pSliderVideoScreenCount);
+    setTabOrder(m_pSliderVideoScreenCount, m_pEditorVideoScreenCount);
+    setTabOrder(m_pEditorVideoScreenCount, m_pCheckbox3D);
+#ifdef VBOX_WITH_VIDEOHWACCEL
+    setTabOrder(m_pCheckbox3D, m_pCheckbox2DVideo);
+    setTabOrder(m_pCheckbox2DVideo, m_pCheckboxRemoteDisplay);
 #else /* VBOX_WITH_VIDEOHWACCEL */
-    setTabOrder(mCb3D, m_pCheckboxRemoteDisplay);
+    setTabOrder(m_pCheckbox3D, m_pCheckboxRemoteDisplay);
 #endif /* !VBOX_WITH_VIDEOHWACCEL */
 
@@ -400,8 +400,8 @@
     /* Video stuff: */
     CSystemProperties sys = vboxGlobal().virtualBox().GetSystemProperties();
-    m_pLabelMemoryMin->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMinVRAM));
-    m_pLabelMemoryMax->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMaxVRAMVisible));
-    m_pLabelScreensMin->setText(tr("<qt>%1</qt>").arg(1));
-    m_pLabelScreensMax->setText(tr("<qt>%1</qt>").arg(sys.GetMaxGuestMonitors()));
+    m_pLabelVideoMemorySizeMin->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMinVRAM));
+    m_pLabelVideoMemorySizeMax->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMaxVRAMVisible));
+    m_pLabelVideoScreenCountMin->setText(tr("<qt>%1</qt>").arg(1));
+    m_pLabelVideoScreenCountMax->setText(tr("<qt>%1</qt>").arg(sys.GetMaxGuestMonitors()));
 
     /* Remote Display stuff: */
@@ -429,5 +429,5 @@
     m_pContainerVideo->setEnabled(isMachineOffline());
 #ifdef VBOX_WITH_VIDEOHWACCEL
-    mCb2DVideo->setEnabled(VBoxGlobal::isAcceleration2DVideoAvailable());
+    m_pCheckbox2DVideo->setEnabled(VBoxGlobal::isAcceleration2DVideoAvailable());
 #endif /* VBOX_WITH_VIDEOHWACCEL */
 
@@ -446,15 +446,15 @@
 void UIMachineSettingsDisplay::sltValueChangedVRAM(int iValue)
 {
-    m_pEditorMemory->setText(QString::number(iValue));
+    m_pEditorVideoMemorySize->setText(QString::number(iValue));
 }
 
 void UIMachineSettingsDisplay::sltTextChangedVRAM(const QString &strText)
 {
-    m_pSliderMemory->setValue(strText.toInt());
+    m_pSliderVideoMemorySize->setValue(strText.toInt());
 }
 
 void UIMachineSettingsDisplay::sltValueChangedScreens(int iValue)
 {
-    m_pEditorScreens->setText(QString::number(iValue));
+    m_pEditorVideoScreenCount->setText(QString::number(iValue));
     checkVRAMRequirements();
 }
@@ -462,5 +462,5 @@
 void UIMachineSettingsDisplay::sltTextChangedScreens(const QString &strText)
 {
-    m_pSliderScreeens->setValue(strText.toInt());
+    m_pSliderVideoScreenCount->setValue(strText.toInt());
 }
 
@@ -554,5 +554,5 @@
 void UIMachineSettingsDisplay::prepareVideoTab()
 {
-    /* Prepare variables: */
+    /* Prepare memory-size slider: */
     CSystemProperties sys = vboxGlobal().virtualBox().GetSystemProperties();
     m_iMinVRAM = sys.GetMinGuestVRAM();
@@ -568,50 +568,52 @@
 
     /* Setup validators: */
-    m_pEditorMemory->setValidator(new QIntValidator(m_iMinVRAM, m_iMaxVRAMVisible, this));
-    m_pEditorScreens->setValidator(new QIntValidator(cMinGuestScreens, cMaxGuestScreens, this));
+    m_pEditorVideoMemorySize->setValidator(new QIntValidator(m_iMinVRAM, m_iMaxVRAMVisible, this));
+    m_pEditorVideoScreenCount->setValidator(new QIntValidator(cMinGuestScreens, cMaxGuestScreens, this));
+
+    /* Setup connections: */
+    connect(m_pSliderVideoMemorySize, SIGNAL(valueChanged(int)), this, SLOT(sltValueChangedVRAM(int)));
+    connect(m_pEditorVideoMemorySize, SIGNAL(textChanged(const QString&)), this, SLOT(sltTextChangedVRAM(const QString&)));
+    connect(m_pSliderVideoScreenCount, SIGNAL(valueChanged(int)), this, SLOT(sltValueChangedScreens(int)));
+    connect(m_pEditorVideoScreenCount, SIGNAL(textChanged(const QString&)), this, SLOT(sltTextChangedScreens(const QString&)));
+
+    /* Setup widgets: */
+    m_pSliderVideoMemorySize->setPageStep(calcPageStep(m_iMaxVRAMVisible));
+    m_pSliderVideoMemorySize->setSingleStep(m_pSliderVideoMemorySize->pageStep() / 4);
+    m_pSliderVideoMemorySize->setTickInterval(m_pSliderVideoMemorySize->pageStep());
+    m_pSliderVideoScreenCount->setPageStep(1);
+    m_pSliderVideoScreenCount->setSingleStep(1);
+    m_pSliderVideoScreenCount->setTickInterval(1);
+
+    /* Setup the scale so that ticks are at page step boundaries: */
+    m_pSliderVideoMemorySize->setMinimum((m_iMinVRAM / m_pSliderVideoMemorySize->pageStep()) * m_pSliderVideoMemorySize->pageStep());
+    m_pSliderVideoMemorySize->setMaximum(m_iMaxVRAMVisible);
+    m_pSliderVideoMemorySize->setSnappingEnabled(true);
+    m_pSliderVideoMemorySize->setErrorHint(0, 1);
+    m_pSliderVideoScreenCount->setMinimum(cMinGuestScreens);
+    m_pSliderVideoScreenCount->setMaximum(cMaxGuestScreens);
+    m_pSliderVideoScreenCount->setErrorHint(0, cMinGuestScreens);
+    m_pSliderVideoScreenCount->setOptimalHint(cMinGuestScreens, cHostScreens);
+    m_pSliderVideoScreenCount->setWarningHint(cHostScreens, cMaxGuestScreens);
+
+    /* Limit min/max. size of QLineEdit: */
+    m_pEditorVideoMemorySize->setFixedWidthByText(QString().fill('8', 4));
+    m_pEditorVideoScreenCount->setFixedWidthByText(QString().fill('8', 4));
+
+    /* Ensure value and validation is updated: */
+    sltValueChangedVRAM(m_pSliderVideoMemorySize->value());
+    sltValueChangedScreens(m_pSliderVideoScreenCount->value());
+
+#ifndef VBOX_WITH_VIDEOHWACCEL
+    /* Hide check-box if not supported: */
+    m_pCheckbox2DVideo->setVisible(false);
+#endif /* VBOX_WITH_VIDEOHWACCEL */
+}
+
+void UIMachineSettingsDisplay::prepareRemoteDisplayTab()
+{
+    /* Setup validators: */
     m_pEditorRemoteDisplayPort->setValidator(new QRegExpValidator(QRegExp("(([0-9]{1,5}(\\-[0-9]{1,5}){0,1}),)*([0-9]{1,5}(\\-[0-9]{1,5}){0,1})"), this));
     m_pEditorRemoteDisplayTimeout->setValidator(new QIntValidator(this));
 
-    /* Setup connections: */
-    connect(m_pSliderMemory, SIGNAL(valueChanged(int)), this, SLOT(sltValueChangedVRAM(int)));
-    connect(m_pEditorMemory, SIGNAL(textChanged(const QString&)), this, SLOT(sltTextChangedVRAM(const QString&)));
-    connect(m_pSliderScreeens, SIGNAL(valueChanged(int)), this, SLOT(sltValueChangedScreens(int)));
-    connect(m_pEditorScreens, SIGNAL(textChanged(const QString&)), this, SLOT(sltTextChangedScreens(const QString&)));
-
-    /* Setup widgets: */
-    m_pSliderMemory->setPageStep(calcPageStep(m_iMaxVRAMVisible));
-    m_pSliderMemory->setSingleStep(m_pSliderMemory->pageStep() / 4);
-    m_pSliderMemory->setTickInterval(m_pSliderMemory->pageStep());
-    m_pSliderScreeens->setPageStep(1);
-    m_pSliderScreeens->setSingleStep(1);
-    m_pSliderScreeens->setTickInterval(1);
-
-    /* Setup the scale so that ticks are at page step boundaries: */
-    m_pSliderMemory->setMinimum((m_iMinVRAM / m_pSliderMemory->pageStep()) * m_pSliderMemory->pageStep());
-    m_pSliderMemory->setMaximum(m_iMaxVRAMVisible);
-    m_pSliderMemory->setSnappingEnabled(true);
-    m_pSliderMemory->setErrorHint(0, 1);
-    m_pSliderScreeens->setMinimum(cMinGuestScreens);
-    m_pSliderScreeens->setMaximum(cMaxGuestScreens);
-    m_pSliderScreeens->setErrorHint(0, cMinGuestScreens);
-    m_pSliderScreeens->setOptimalHint(cMinGuestScreens, cHostScreens);
-    m_pSliderScreeens->setWarningHint(cHostScreens, cMaxGuestScreens);
-
-    /* Limit min/max. size of QLineEdit: */
-    m_pEditorMemory->setFixedWidthByText(QString().fill('8', 4));
-    m_pEditorScreens->setFixedWidthByText(QString().fill('8', 4));
-
-    /* Ensure value and validation is updated: */
-    sltValueChangedVRAM(m_pSliderMemory->value());
-    sltValueChangedScreens(m_pSliderScreeens->value());
-
-#ifndef VBOX_WITH_VIDEOHWACCEL
-    /* Hide check-box if not supported: */
-    mCb2DVideo->setVisible(false);
-#endif /* VBOX_WITH_VIDEOHWACCEL */
-}
-
-void UIMachineSettingsDisplay::prepareRemoteDisplayTab()
-{
     /* Prepare auth-method combo: */
     m_pComboRemoteDisplayAuthMethod->insertItem(0, ""); /* KAuthType_Null */
@@ -697,5 +699,5 @@
 
     /* Get monitors count and base video memory requirements: */
-    int cGuestScreenCount = m_pSliderScreeens->value();
+    int cGuestScreenCount = m_pSliderVideoScreenCount->value();
     quint64 uNeedMBytes = VBoxGlobal::requiredVideoMemory(m_guestOSType.GetId(), cGuestScreenCount) / _1M;
 
@@ -708,5 +710,5 @@
 
 #ifdef VBOX_WITH_VIDEOHWACCEL
-    if (mCb2DVideo->isChecked() && m_f2DVideoAccelerationSupported)
+    if (m_pCheckbox2DVideo->isChecked() && m_f2DVideoAccelerationSupported)
     {
         uNeedMBytes += VBoxGlobal::required2DOffscreenVideoMemory() / _1M;
@@ -714,10 +716,10 @@
 #endif /* VBOX_WITH_VIDEOHWACCEL */
 #ifdef VBOX_WITH_CRHGSMI
-    if (mCb3D->isChecked() && m_fWddmModeSupported)
+    if (m_pCheckbox3D->isChecked() && m_fWddmModeSupported)
     {
 # if 0
         uNeedMBytes += VBoxGlobal::required3DWddmOffscreenVideoMemory(m_guestOSType.GetId(), cGuestScreenCount) / _1M;
-        uNeedMBytes = RT_MAX(uNeedMBytes, 128);
-        uNeedMBytes = RT_MIN(uNeedMBytes, 256);
+        uNeedMBytes = qMax(uNeedMBytes, 128);
+        uNeedMBytes = qMin(uNeedMBytes, 256);
 # endif
         m_iMaxVRAMVisible = 256;
@@ -725,10 +727,10 @@
 #endif /* VBOX_WITH_CRHGSMI */
 
-    m_pSliderMemory->setWarningHint(1, uNeedMBytes);
-    m_pSliderMemory->setPageStep(calcPageStep(m_iMaxVRAMVisible));
-    m_pSliderMemory->setMaximum(m_iMaxVRAMVisible);
-    m_pSliderMemory->setOptimalHint(uNeedMBytes, m_iMaxVRAMVisible);
-    m_pEditorMemory->setValidator(new QIntValidator(m_iMinVRAM, m_iMaxVRAMVisible, this));
-    m_pLabelMemoryMax->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMaxVRAMVisible));
+    m_pSliderVideoMemorySize->setWarningHint(1, uNeedMBytes);
+    m_pSliderVideoMemorySize->setPageStep(calcPageStep(m_iMaxVRAMVisible));
+    m_pSliderVideoMemorySize->setMaximum(m_iMaxVRAMVisible);
+    m_pSliderVideoMemorySize->setOptimalHint(uNeedMBytes, m_iMaxVRAMVisible);
+    m_pEditorVideoMemorySize->setValidator(new QIntValidator(m_iMinVRAM, m_iMaxVRAMVisible, this));
+    m_pLabelVideoMemorySizeMax->setText(tr("<qt>%1&nbsp;MB</qt>").arg(m_iMaxVRAMVisible));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.ui	(revision 46461)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsDisplay.ui	(revision 46473)
@@ -35,5 +35,5 @@
          <layout class="QGridLayout" name="m_pLayoutContainerVideo">
           <item row="0" column="0">
-           <widget class="QLabel" name="m_pLabelMemory">
+           <widget class="QLabel" name="m_pLabelVideoMemorySize">
             <property name="text">
              <string>Video &amp;Memory:</string>
@@ -43,15 +43,15 @@
             </property>
             <property name="buddy">
-             <cstring>m_pEditorMemory</cstring>
+             <cstring>m_pEditorVideoMemorySize</cstring>
             </property>
            </widget>
           </item>
           <item row="0" column="1" rowspan="2">
-           <layout class="QVBoxLayout" name="m_pLayoutSliderMemory">
+           <layout class="QVBoxLayout" name="m_pLayoutVideoMemorySizeSlider">
             <property name="spacing">
              <number>0</number>
             </property>
             <item>
-             <widget class="QIAdvancedSlider" name="m_pSliderMemory">
+             <widget class="QIAdvancedSlider" name="m_pSliderVideoMemorySize">
               <property name="whatsThis">
                <string>Controls the amount of video memory provided to the virtual machine.</string>
@@ -66,10 +66,10 @@
             </item>
             <item>
-             <layout class="QHBoxLayout" name="m_pLayoutLegendMemory">
+             <layout class="QHBoxLayout" name="m_pLayoutVideoMemorySizeLegeng">
               <item>
-               <widget class="QLabel" name="m_pLabelMemoryMin"/>
+               <widget class="QLabel" name="m_pLabelVideoMemorySizeMin"/>
               </item>
               <item>
-               <spacer name="m_pSpacerLegendMemory">
+               <spacer name="m_pSpacerVideoMemorySize">
                 <property name="orientation">
                  <enum>Qt::Horizontal</enum>
@@ -84,5 +84,5 @@
               </item>
               <item>
-               <widget class="QLabel" name="m_pLabelMemoryMax"/>
+               <widget class="QLabel" name="m_pLabelVideoMemorySizeMax"/>
               </item>
              </layout>
@@ -91,7 +91,7 @@
           </item>
           <item row="0" column="2">
-           <layout class="QHBoxLayout" name="m_pLayoutEditorMemory">
+           <layout class="QHBoxLayout" name="m_pLayoutVideoMemorySizeEditor">
             <item>
-             <widget class="QILineEdit" name="m_pEditorMemory">
+             <widget class="QILineEdit" name="m_pEditorVideoMemorySize">
               <property name="sizePolicy">
                <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
@@ -106,11 +106,5 @@
             </item>
             <item>
-             <widget class="QLabel" name="m_pLabelMemoryUnit">
-              <property name="sizePolicy">
-               <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
-                <horstretch>0</horstretch>
-                <verstretch>0</verstretch>
-               </sizepolicy>
-              </property>
+             <widget class="QLabel" name="m_pLabelVideoMemorySizeUnit">
               <property name="text">
                <string>MB</string>
@@ -121,5 +115,5 @@
           </item>
           <item row="2" column="0">
-           <widget class="QLabel" name="m_pLabelScreens">
+           <widget class="QLabel" name="m_pLabelVideoScreenCount">
             <property name="text">
              <string>Mo&amp;nitor Count:</string>
@@ -129,15 +123,15 @@
             </property>
             <property name="buddy">
-             <cstring>m_pEditorScreens</cstring>
+             <cstring>m_pEditorVideoScreenCount</cstring>
             </property>
            </widget>
           </item>
           <item row="2" column="1" rowspan="2">
-           <layout class="QVBoxLayout" name="m_pLayoutSliderScreens">
+           <layout class="QVBoxLayout" name="m_pLayoutVideoScreenCount">
             <property name="spacing">
              <number>0</number>
             </property>
             <item>
-             <widget class="QIAdvancedSlider" name="m_pSliderScreeens">
+             <widget class="QIAdvancedSlider" name="m_pSliderVideoScreenCount">
               <property name="whatsThis">
                <string>Controls the amount of virtual monitors provided to the virtual machine.</string>
@@ -152,17 +146,10 @@
             </item>
             <item>
-             <layout class="QHBoxLayout" name="m_pLayoutLegendScreens">
+             <layout class="QHBoxLayout" name="m_pLayoutVideoScreenCountLegeng">
               <item>
-               <widget class="QLabel" name="m_pLabelScreensMin">
-                <property name="sizePolicy">
-                 <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
-                  <horstretch>0</horstretch>
-                  <verstretch>0</verstretch>
-                 </sizepolicy>
-                </property>
-               </widget>
+               <widget class="QLabel" name="m_pLabelVideoScreenCountMin"/>
               </item>
               <item>
-               <spacer name="m_pSpacerLegendScreens">
+               <spacer name="m_pSpacerVideoScreenCount">
                 <property name="orientation">
                  <enum>Qt::Horizontal</enum>
@@ -177,12 +164,5 @@
               </item>
               <item>
-               <widget class="QLabel" name="m_pLabelScreensMax">
-                <property name="sizePolicy">
-                 <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
-                  <horstretch>0</horstretch>
-                  <verstretch>0</verstretch>
-                 </sizepolicy>
-                </property>
-               </widget>
+               <widget class="QLabel" name="m_pLabelVideoScreenCountMax"/>
               </item>
              </layout>
@@ -193,5 +173,5 @@
            <layout class="QHBoxLayout" name="m_pLayoutEditorScreens">
             <item>
-             <widget class="QILineEdit" name="m_pEditorScreens">
+             <widget class="QILineEdit" name="m_pEditorVideoScreenCount">
               <property name="sizePolicy">
                <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
@@ -206,5 +186,5 @@
             </item>
             <item>
-             <widget class="QLabel" name="m_pLabelScreensUnit"/>
+             <widget class="QLabel" name="m_pLabelVideoScreenCountUnit"/>
             </item>
            </layout>
@@ -221,5 +201,5 @@
           </item>
           <item row="4" column="1" colspan="2">
-           <widget class="QCheckBox" name="mCb3D">
+           <widget class="QCheckBox" name="m_pCheckbox3D">
             <property name="sizePolicy">
              <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
@@ -237,5 +217,5 @@
           </item>
           <item row="5" column="1" colspan="2">
-           <widget class="QCheckBox" name="mCb2DVideo">
+           <widget class="QCheckBox" name="m_pCheckbox2DVideo">
             <property name="sizePolicy">
              <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">